::  =====================================
::  GUILD WARS 2 LAUNCHER pour Windows 10
::  Version : 4.1
::  Date : 2020.12.29
::  =====================================


::  =====================================
::  EDITER LES VARIABLES SOUS CETTE LIGNE
::  =====================================

::  Vous devez aussi editer le fichier 'GuildWars2_UpdateArcDps.cmd'
::  afin d'y inscrire aussi l'emplacement du dossier de Guild Wars 2 !

::  [== DOSSIER DE GUILD WARS 2 ==]
::  Indiquer ici le chemin complet du dossier du jeu (SANS LE \ FINAL)
::  Ne changer que la valeur apres le signe = sans guillemets !

set gw2Path=C:\Program Files (x86)\Guild Wars 2

::  [== EXECUTABLE DE GUILD WARS 2 ==]
::  Nom de l'executable de Guild Wars 2 (AVEC LE .EXE)
::  Ne changer que la valeur apres le signe = sans guillemets !
::  ArcDPS ne fonctionne qu'avec la version 64 bits du jeu

set gw2Exe=Gw2-64.exe

::  [== ARGUMENTS (OPTIONNEL) ==]
::  Ajouter tous les arguments de ligne de commande dont vous avez besoin, entoure de guillemets.
::  Separer les arguments par une virgule et un espace.
::  Laisser "" vide si aucun arguments utilises
::  Liste des arguments possibles : https://wiki-fr.guildwars2.com/wiki/Ligne_de_commande

set cmdLine=""

::  ==================================
::  NE RIEN MODIFIER APRES CETTE LIGNE
::  ==================================


:Global
@echo off
color 70
title Assistant de lancement de Guild Wars 2

:Menu
cls
echo.
echo.[32m ASSISTANT DE LANCEMENT DE GUILD WARS 2
echo. --------------------------------------[30;47m
echo.
echo. 1. Demarrage AVEC mise a jour d'ArcDPS
echo. 2. Demarrage SANS mise a jour d'ArcDPS
echo.[33m    -----------
echo.    MAINTENANCE
echo.    -----------[30;47m
echo. 3. Effacer les fichiers temporaires de Guild Wars 2
echo. 4. Effacer le cache du client de Guild Wars 2
echo. 5. Effectuer un diagnostique de l'ordinateur
echo. 6. Analyser et reparer les fichiers du jeu
echo.    -----------
echo. 0. [31mFermer[30;47m
echo.
echo. --------------------------------------
choice /c 1234560 /n /m "> Choisir l'option de demarrage : "
if %errorlevel% == 1 goto Guildwars2_ArcDPS_Update
if %errorlevel% == 2 goto Guildwars2_ArcDPS_NoCheck
if %errorlevel% == 3 goto Guildwars2_Cache
if %errorlevel% == 4 goto Guildwars2_Client
if %errorlevel% == 5 goto Guildwars2_Diagnostic
if %errorlevel% == 6 goto Guildwars2_Repair
if %errorlevel% == 7 goto Close
goto Menu

:Guildwars2_ArcDPS_Update
cls
echo.
echo. [32m---------------------------------------------------
echo. Demarrage de Guild Wars 2 AVEC mise a jour d'ArcDPS
echo. ---------------------------------------------------[30;47m
echo.
if exist "%gw2Path%\GuildWars2_UpdateArcDps.cmd" (
    call "%gw2Path%\GuildWars2_UpdateArcDps.cmd"
    goto Close
) else (
    echo. [31mLe fichier "GuildWars2_UpdateArcDps.cmd" est introuvable ![30;47m
    ping 127.0.0.1 -n 2 >nul 2>&1
    echo. Demarrage du jeu sans controle de version d'ArcDPS ...
    ping 127.0.0.1 -n 2 >nul 2>&1
    tasklist | findstr /c:%gw2Exe% >nul
    if %errorlevel% == 0 (
        echo. Guild Wars 2 est deja en cours d'execution !
        ping 127.0.0.1 -n 2 >nul 2>&1
        goto Close
    ) else (
        echo. Demarrage de Guild Wars 2 ...
        start "Guild Wars 2" "%gw2Path%\%gw2Exe%" %cmdLine%
        goto Close
    )
)

:Guildwars2_ArcDPS_NoCheck
cls
echo.
echo. [32m---------------------------------------------------
echo. Demarrage de Guild Wars 2 SANS mise a jour d'ArcDPS
echo. ---------------------------------------------------[30;47m
echo.
tasklist | findstr /c:%gw2Exe% >nul
if %errorlevel% == 0 (
    echo. Guild Wars 2 est deja en cours d'excution !
    ping 127.0.0.1 -n 2 >nul 2>&1
    goto Close
)
echo. Demarrage de Guild Wars 2 ...
ping 127.0.0.1 -n 2 >nul 2>&1
start "Guild Wars 2" "%gw2Path%\%gw2Exe%" %cmdLine%
goto Close

:Guildwars2_Cache
cls
echo.
echo. [33m------------------------------------------------
echo. Effacer les fichiers temporaires de Guild Wars 2
echo. ------------------------------------------------[30;47m
echo.
echo. [31m/!\ Si le jeu est en cours d'utilisation, il sera ferme ![30;47m
echo.
echo. Uniquement les fichiers temporaires relatifs a Guild Wars 2 seront supprimes.
echo.
echo. Localisation des fichiers :
echo. %Temp%\gw2cache-{CHIFFRES ALEATOIRES}
echo.
choice /c ON /m "> Confirmer la suppression des fichiers temporaires ? "
if %errorlevel% == 1 goto Delete_Cache
if %errorlevel% == 2 goto Menu
:Delete_Cache
echo.
tasklist | findstr /c:%gw2Exe% >nul
if %errorlevel% == 0 (
    echo. Guild Wars 2 est en cours d'execution !
    ping 127.0.0.1 -n 2 >nul 2>&1
    echo. Fermeture de Guild Wars 2 ...
    ping 127.0.0.1 -n 2 >nul 2>&1
    taskkill /f /im %gw2Exe% >nul 2>&1
)
echo. Suppression des fichiers temporaires ...
for /d %%G in ("%Temp%\gw2cache*") do rd /s /q "%%~G" >nul 2>&1
echo. Suppression terminee
ping 127.0.0.1 -n 2 >nul 2>&1
goto Menu

:Guildwars2_Client
cls
echo.
echo. [33m------------------------------------------
echo. Effacer le cache du client de Guild Wars 2
echo. ------------------------------------------[30;47m
echo.
echo. [31m/!\ Si le jeu est en cours d'utilisation, il sera ferme ![30;47m
echo.
echo. Cela efface totalement vos reglages personnels (graphiques, sons, raccourcis).
echo. Et remet le jeu tel que lors de sa premiere installation.
echo. Ceci peux corriger des problemes relatifs a l'hotel des ventes.
echo. Ne necessite pas de retelechargement de fichiers.
echo.
echo. Localisation du fichier :
echo. %APPDATA%\Guild Wars 2\Local.dat
echo.
choice /c ON /m "> Confirmer la suppression du cache du client ? "
if %errorlevel% == 1 goto Delete_Client_Cache
if %errorlevel% == 2 goto Menu
:Delete_Client_Cache
echo.
tasklist | findstr /c:%gw2Exe% >nul
if %errorlevel% == 0 (
    echo. Guild Wars 2 est en cours d'execution !
    ping 127.0.0.1 -n 2 >nul 2>&1
    echo. Fermeture de Guild Wars 2 ...
    ping 127.0.0.1 -n 2 >nul 2>&1
    taskkill /f /im %gw2Exe% >nul 2>&1
)
echo. Suppression du fichier de cache client ...
del /Q "%APPDATA%\Guild Wars 2\Local.dat" >nul 2>&1
echo. Suppression terminee
ping 127.0.0.1 -n 2 >nul 2>&1
goto Menu

:Guildwars2_Diagnostic
cls
echo.
echo. [33m-----------------------------------------
echo. Effectuer un diagnostique de l'ordinateur
echo. -----------------------------------------[30;47m
echo.
echo. [31m/!\ Si le jeu est en cours d'utilisation, il sera ferme ![30;47m
echo.
echo. Le fichier de diagnostique 'NetworkDiag.log' sera enregistre dans le dossier du jeu.
echo. ou dans votre dossier : "%USERPROFILE%\Documents\Guild Wars 2".
echo. Ce fichier peux vous etre demande dans certains cas par le support client de Guild Wars 2.
echo.
choice /c ON /m "> Voulez-vous lancer le mode diagnostique ? "
if %errorlevel% == 1 goto Diagnostic
if %errorlevel% == 2 goto Menu
:Diagnostic
tasklist | findstr /c:%gw2Exe% >nul
if %errorlevel% == 0 (
    echo. Guild Wars 2 est en cours d'execution !
    ping 127.0.0.1 -n 2 >nul 2>&1
    echo. Fermeture de Guild Wars 2 ...
    ping 127.0.0.1 -n 2 >nul 2>&1
    taskkill /f /im %gw2Exe% >nul 2>&1
    echo.
    echo. Redemarrage de Guild Wars 2 en mode diagnostique ...
    start "Guild Wars 2" "%gw2Path%\%gw2Exe%" -diag
) else (
    echo. Demarrage de Guild Wars 2 en mode diagnostique ...
    start "Guild Wars 2" "%gw2Path%\%gw2Exe%" -diag
)
goto Menu

:Guildwars2_Repair
cls
echo.
echo. [33m------------------------------------------------
echo. Analyser et reparer les fichiers de Guild Wars 2
echo. ------------------------------------------------[30;47m
echo.
echo. [31m/!\ Si le jeu est en cours d'utilisation, il sera ferm ![30;47m
echo.
echo. Les donnees du jeu contenu dans 'Gw2.dat' vont etre verifies.
echo. Les fichiers corrompues ou absents seront retelecharges automatiquement.
echo. Ne pas fermer le client du jeu durant cette procedure !
echo.
choice /c ON /m "> Confirmer la verification des donnees du jeu ? "
if %errorlevel% == 1 goto Repair
if %errorlevel% == 2 goto Menu
:Repair
tasklist | findstr /c:%gw2Exe% >nul
if %errorlevel% == 0 (
    echo. Guild Wars 2 est en cours d'execution !
    ping 127.0.0.1 -n 2 >nul 2>&1
    echo. Fermeture de Guild Wars 2 ...
    ping 127.0.0.1 -n 2 >nul 2>&1
    taskkill /f /im %gw2Exe% >nul 2>&1
    echo.
    echo. Redemarrage de Guild Wars 2 en mode reparation ...
    start "Guild Wars 2" "%gw2Path%\%gw2Exe%" -repair
) else (
    echo. Demarrage de Guild Wars 2 en mode reparation ...
    start "Guild Wars 2" "%gw2Path%\%gw2Exe%" -repair
)
goto Menu

:Close
cls
echo.
echo. Fermeture de l'assistant de demarrage ...
echo. Passez une bonne journee (^^^^,)
ping 127.0.0.1 -n 2 >nul 2>&1
exit