REM <#
@echo off
copy GuildWars2_UpdateArcDPS.cmd GuildWars2_UpdateArcDPS.ps1 >NUL
PowerShell.exe -ExecutionPolicy Unrestricted -NoProfile -Command "&{Set-Alias REM Write-Host; .\GuildWars2_UpdateArcDPS.ps1}"
del GuildWars2_UpdateArcDPS.ps1
exit
REM #>


<# ----------------------------------
   NE RIEN MODIFIER AVANT CETTE LIGNE
   ---------------------------------- #>


<# ---- DOSSIER DE GUILD WARS 2 ----
   crire ci-dessous le chemin complet vers le dossier du jeu (sans le dernier \ )
   Ne pas oublier les "" au dbut et  la fin du chemin !
   Exemples courants :
   $gw2Path = "C:\Program Files (x86)\Guild Wars 2"
   $gw2Path = "D:\Jeux\Guild Wars 2"
   --------------------------------- #>

$gw2Path = "C:\Program Files (x86)\Guild Wars 2"


<# ---- EXECUTABLE DE GUILD WARS 2 ----
   Nom de l'executable de Guild Wars 2 (sans .exe)
   ArcDPS ne fonctionne qu'avec la version 64 bits du jeu
   ------------------------------------ #>

$gw2Exe = "Gw2-64"


<# ---- ARGUMENTS (OPTIONNEL) ----
   Ajoutez tous les arguments de ligne de commande dont vous avez besoin ici, spars par une virgule et entours de guillemets.
   Liste des arguments disponibles : https://wiki-fr.guildwars2.com/wiki/Ligne_de_commande
   Laisser vide (sans retirer les "") si aucun arguments
   ------------------------------- #>

$cmdLine = ""


<# ----------------------------------
   NE RIEN MODIFIER APRS CETTE LIGNE
   ---------------------------------- #>


<# ---- URLS D'ARCDPS ---- #>
$md5Url   = "https://www.deltaconnected.com/arcdps/x64/d3d9.dll.md5sum"
$d3d9Url  = "https://www.deltaconnected.com/arcdps/x64/d3d9.dll"


<# ---- DMARRAGE DE GUILD WARS 2 ---- #>
function Demarrage-GW2
{
	Write-Host " "
	Write-Host " Lancement de Guild Wars 2 ..."
	Start-Sleep -s 2

	if ($cmdLine.Length -lt 1)
	{
		Start-Process -FilePath "$($gw2Path)\$($gw2Exe).exe"
	}
	else
	{
		Start-Process -FilePath "$($gw2Path)\$($gw2Exe).exe" -ArgumentList $cmdLine
	}
}


<# ---- TLCHARGEMENT D'ARCDPS ---- #>
function Telecharge-ArcDps
{
	Write-Host " Tlchargement des fichiers d'ArcDps ..."
	Start-Sleep -s 2

	$d3d9Response = Invoke-WebRequest -Uri $d3d9Url -UseBasicParsing
	Set-Content -Path "$($gw2Path)\bin64\d3d9.dll" -Encoding Byte -Value $d3d9Response.Content

	Write-Host " Installation des fichiers d'ArcDps termine"
	Start-Sleep -s 2

	Demarrage-GW2
}


<# ---- CONTRLE D'ARCDPS ---- #>
function Controle-ArcDps
{
	if ((Get-Process $gw2Exe -ErrorAction 0).Count -gt 0)
	{
		Write-Host " Guild Wars 2 est en cours d'execution !"
		Start-Sleep -s 1

		Write-Host " Guild Wars 2 va tre ferm avant de continuer."
		Start-Sleep -s 2

		Stop-Process -Name $gw2Exe
		Start-Sleep -s 2
	}

	Write-Host " Vrification de la version d'ArcDps ..."

	$fileExists = Test-Path "$($gw2Path)\bin64\d3d9.dll"

	if ($fileExists)
	{
		$currD3d9 = Get-FileHash "$($gw2Path)\bin64\d3d9.dll" -Algorithm MD5

		try
		{
			$md5response = Invoke-WebRequest -Uri $md5Url -UseBasicParsing
		}
		catch
		{
			Write-Host " Erreur : chec du tlchargement du fichier de contrle MD5." -ForegroundColor Red
			Write-Host " ArcDps n'a pas t install ou mis  jour !" -ForegroundColor Red
			Write-Host " Veuillez reessayer ultrieurement ..." -ForegroundColor Red
			Start-Sleep -s 5

			Demarrage-GW2

			Exit
		}

		if (!$currD3d9.Hash.Equals(($md5response.ToString().Split(" ",[System.StringSplitOptions]::RemoveEmptyEntries)[0]), [System.StringComparison]::InvariantCultureIgnoreCase))
		{
			Write-Host " Une version plus rcente d'ArcDps va tre install ..." -ForegroundColor DarkYellow
			Start-Sleep -s 2

			Write-Host " Copie de sauvegarde des anciens fichiers ..."
			Start-Sleep -s 2

			Copy-Item "$($gw2Path)\bin64\d3d9.dll" -Destination "$($gw2Path)\bin64\d3d9.dll.bak" -Force

			Telecharge-ArcDps
		}
		else
		{
			Write-Host " Votre version d'ArcDps est dj  jour !" -ForegroundColor Green
			Start-Sleep -s 2

			Demarrage-GW2
		}
	}
	else
	{
		Telecharge-ArcDps
	}
}


<# ---- LANCEMENT DU SCRIPT ---- #>
Controle-ArcDps